var mainWindow;
var fb;

function init_sidebar() {
	mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);
	fb = mainWindow.fireBible;
	fbItemList.init();
	fbTreeView.init();
}

var fbItemList = {
	
	init : function() {
		this.listbox = document.getElementById("firebible-itemlist");
		if (fb.initUtils()) {
			this.jSword = fb.getJSword();
			this.fillItemList();
		} else {
			mainWindow.toggleSidebar('viewFireBibleSidebar');
		}
	},
	
	fillItemList : function() {
		this.modules = new Array();
		var bibleList = this.jSword.getSidebarModules();
		for (var i = 0; i < bibleList.size(); i++) {
			var bible = bibleList.get(i);
			this.modules[i] = bible;
			var listItem = this.listbox.appendItem(bible.getName());
			var bClass = this.jSword.utilKlass.getBookClass(bible);			
			listItem.setAttribute("class","listitem-iconic " + bClass);
		}
	},
	
	selectionChanged : function() {
		var module = this.modules[this.listbox.currentIndex];
		fbTreeView.update(module, this.jSword);
	}
};

var fbTreeView = {
	
	init: function() {		
		this.tree = document.getElementById("firebible-tree");
		this.mini = document.getElementById("firebible-mini");
		this.tree.view = this;
	},
	
	visibleData : [],
	
	update : function(module, jSword) {
		this.module = module;
		this.jSword = jSword;
		var removed = this.visibleData.length;
		this.visibleData = new Array();
		this.addChildren(module.getGlobalKeyList(), 0, 0, removed, 
						jSword.utilKlass.isListBook(module), this.module);
	},
	
	addChildren : function(pKey, index, level, removed, isList, module) {		
		var keys = this.jSword.utilKlass.getKeyChildren(pKey, module);
		var nChildren;
		var temp = new Array();
		if (isList) {
			var parts = keys.split("\n");
			nChildren = parts.length;
			for (var i = 0; i < nChildren; i++) {
				var jItem = parts[i];
				temp[i] = [null, level, jItem, false, false];
			}			
		} else {
			nChildren = keys.length;
			for (var i = 0; i < nChildren; i++) {
				var jItem = keys[i];
				temp[i] = [jItem[0], level, jItem[1], jItem[2], false];
			}
		}
		
		if (index == 0) {
			this.visibleData = temp;
		} else {
			for (var i = 0; i < nChildren; i++) {
				this.visibleData.splice(index + i, 0, temp[i]);
			}
		}
		this.treeBox.rowCountChanged(index, nChildren - removed);
	},

	treeBox: null,
  	selection: null,

	  get rowCount()                     { return this.visibleData.length; },
	  setTree: function(treeBox)         { this.treeBox = treeBox; },
	  getCellText: function(idx, column) { return this.visibleData[idx][2]; },
	  isContainer: function(idx)         { return this.visibleData[idx][3]; },
	  isContainerOpen: function(idx)     { return this.visibleData[idx][4]; },
	  isContainerEmpty: function(idx)    { return false; },
	  isSeparator: function(idx)         { return false; },
	  isSorted: function()               { return false; },
	  isEditable: function(idx, column)  { return false; },
	
	  getParentIndex: function(idx) {
	    for (var t = idx - 1; t >= 0 ; t--) {
	      if (this.isContainer(t)) return t;
	    }
	    return -1;
	  },
	  
	  getLevel: function(idx) {
	  	return this.visibleData[idx][1];
	  },
	  
	  hasNextSibling: function(idx, after) {
	    var thisLevel = this.getLevel(idx);
	    for (var t = idx + 1; t < this.visibleData.length; t++) {
	      var nextLevel = this.getLevel(t)
	      if (nextLevel == thisLevel) return true;
	      else if (nextLevel < thisLevel) return false;
	    }
	  },
	  
	  toggleOpenState: function(idx) {
	    var item = this.visibleData[idx];
	    
	    if (!item[3]) return; //can't have children, probably shouldn't get here...
	
	    if (!item[4]) {	      
	      item[4] = true;
	      this.addChildren(item[0], idx + 1, item[1] + 1, 0, false, null);
	    } else {
		  item[4] = false;	
	      var thisLevel = this.getLevel(idx);
	      var deletecount = 0;
	      for (var t = idx + 1; t < this.visibleData.length; t++) {
	        if (this.getLevel(t) > thisLevel) deletecount++;
	        else break;
	      }
	      if (deletecount) {
	        this.visibleData.splice(idx + 1, deletecount);
	        this.treeBox.rowCountChanged(idx + 1, -deletecount);
	      }
	    }
	  },
	  
	  keySelectionChanged: function() {
	  	var item = this.visibleData[this.tree.currentIndex];
	  	var key;
	  	var uri = "sword://" + this.module.getInitials();
	  	if (item[0] == null) {
	  		//not a tree key
	  		key = "/" + escape(item[2]);
	  		//this.mini.loadURI(uri + key);
	  	} else {
	  		var cKey = item[0];
	  		key = "";
	  		while (cKey != null) {
	  			key = "/" + escape(cKey.getName()) + key;
	  			//key = escape(cKey.getName()) + "/" + key;
	  			cKey = cKey.getParent(); 
	  		}
	  		key = key.substring(1); //remove the first leading slash, even top level elements have a "root" parent which will lead to an extra / in the URI
	  		//fb.getGBrowser().loadURI(uri + key);
	  	}
	  	if (item[0] != null || this.jSword.utilKlass.isMap(this.module)) {
	  		fb.getGBrowser().loadURI(uri + key);
	  	} else {
	  		this.mini.loadURI(uri + key);
	  	}
	  },
	
	  getImageSrc: function(idx, column) {},
	  getProgressMode : function(idx,column) {},
	  getCellValue: function(idx, column) {},
	  cycleHeader: function(col, elem) {},
	  selectionChanged: function() {},
	  cycleCell: function(idx, column) {},
	  performAction: function(action) {},
	  performActionOnCell: function(action, index, column) {},
	  getRowProperties: function(idx, column, prop) {},
	  getCellProperties: function(idx, column, prop) {},
	  getColumnProperties: function(column, element, prop) {},

};